GENPMDA(1)

NAME
genpmda - Performance Co-Pilot PMDA Generator

SYNOPSIS
genpmda [-dv] [-D domain] [-n pmns] [-o dir] [-s stdpmid] [-t topdir] -c config -i IAM

DESCRIPTION
genpmda is a rapid application development tool for creating new Performance Metrics Domain Agents, see PMDA(3). It provides a very easy and efficient way to extend the Performance Co-pilot (PCP) with new performance metrics without needing to understand the low level details of how PMDAs are constructed.

genpmda reads a config file containing an augmented Performance Metrics Name Space, see PMNS(5), and automatically generates virtually all of the source code to implement a fully functional PMDA, including the Makefile, name space, support scripts for configuring the new PMDA, and the metrics help text. Fairly simple PMDAs can be automatically generated from the config file without writing any additional code. More complicated PMDAs, e.g. containing multiple instance domains, require only the refresh methods for the instance domains to be written manually.

An example of the config file format accepted by genpmda is given below.

OPTIONS

Required options:

-c config
    input config file, see example below

-i IAM
    PMDA name IAM, should appear in stdpmid or the -D option must be used to specify a domain.

Other options:

-d  generate an Install script for a daemon PMDA (default is DSO)

-D domain
    use domain number in the generated pmns and domain.h (if -s is not given)

-n pmns
    use pmns as root of the namespace (default matches -i flag)

-o dir
    use dir for generated source code, default ./generated

-s stdpmid
    path to stdpmid (default ../../pmns/stdpmid)

-t topdir
    use topdir in generated GNUmakefile, default ../../..

-v  print verbose messages about what genpmda is doing.

Example:
    Generate an "example" PMDA using domain 99:

    genpmda -D 99 -v -i EXAMPLE -c example.conf Here is example.conf config file (for the required -c option):

example {
    metric
}
example.metric {
    ##  metric            string
    ##  pmid              EXAMPLE:CLUSTER:0
    ##  indom             PM_INDOM_NULL
    ##  type              PM_TYPE_STRING
    ##  units             PMDA_PMUNITS(0,0,0,0,0,0)
    ##  semantics         PM_SEM_DISCRETE
    ##  briefhelptext     one line help text for example.metric.string
    ##  helptext          long help text for example.metric.string
    ##  helptext          This is the second line of the long help text
    ##  helptext          and this is the third line.
    ##  fetch             function example_string_fetch_callback
    ##  code              atom->cp = "hello world";
    ##  code              return 1;
    ##  endmetric
}

PCP ENVIRONMENT
Environment variables with the prefix PCP_ are used to parameterize the file and directory names used by PCP. On each installation, the file /etc/pcp.conf contains the local values for these variables. The $PCP_CONF variable may be used to specify an alternative configuration file, as described in pcp.conf(5).

SEE ALSO
pmcd(1), PMDA(3), pcp.conf(5), pcp.env(5) and PMNS(5).